c       VERSION 1.3  10/22/92
c**********************************************************************
c       
c                       ==================
c                       SUBROUTINE : WRDAT
c                       ==================
c
c       This write the parameters contained in the common block
c       defined in eprdat.inc into a file in a form that can be read 
c       by rddat.f. Now an identification string for version 1.3 is
c       also written with the parameter file.
c
c       Notes:
c               Care should be taken to ensure that the common 
c               block definition in the include file eprdat.inc
c               is consistent with the information stored in the
c               disk files by this routine to avoid corrupting 
c               the parameter file.
c
c       written by DJS 15-NOV-87
c       modified by DEB 13-MAR-92 to use longer filenames
c                       22-OCT-92 to write identification string
c
c       Includes:
c               stdio.inc
c               eprdat.inc
c
c       Uses:
c
c**********************************************************************
c
      subroutine wrdat(prname,namlth)
      implicit none
c
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'srsdat.inc'
c
      character prname*30, prmid*8
      integer i,j,namlth
c
      data prmid / 'EPRSR1.0' /
c
c######################################################################
c
c----------------------------------------------------------------------
c     open parameter file
c----------------------------------------------------------------------
c
      open (unit=ludisk,file=prname(:namlth),status='unknown',
     #     access='sequential',form='unformatted')
c
        write (ludisk) prmid,
     #  gxx,gyy,gzz,axx,ayy,azz,dr,dp,dm,
     #  d0r,d0p,drt,dpt,dmt,d0rt,d0pt,
     #	oss,osst,psi,bag,bed,
     #  b0,fieldi,fieldf,cgtol,shiftr,shifti,
     #	a0,g0,btol,
     #  a20,a22,a40,a42,
     #  b10,b20,c20,c22,c40,c42,
     #  (fgm(i),i=1,5),(fam(i),i=1,5),
     #  ((d2psi(i,j),i=1,5),j=1,5),
     #  ((d2bed(i,j),i=1,5),j=1,5),
c
     #  cmax
c
        write (ludisk)
     #	in2,itype,
     #  lemx,lomx,mmx,kmx,jmx,nmx,imx,ipnmx,
     #  nfield,nstep,
     #  ndim,neltot,nelv,nelre,nelim,
     #  jdelta,kdelta,lkmdff,lkmtrc
c
c----------------------------------------------------------------------
c     close parameter file
c----------------------------------------------------------------------
c
      close (unit=ludisk)
c
c----------------------------------------------------------------------
c     return to caller
c----------------------------------------------------------------------
c
      return
      end




