c VERSION 1.2 4/22/92
c**********************************************************************
c                    =========================
c                     subroutine WRPARM
c                    =========================
c  Outputs a formatted summary of EPRL calculation parameters to the
c  specified logical unit
c
c  modified from subroutine of same name by DJS
c  DEB 22-APRIL-1992
c**********************************************************************
c
      subroutine wrparm(prname,lth,lu)
c
      include 'rndoff.inc'
      include 'eprdat.inc'
c
      character*30 prname
      integer lu,lth
c
      integer i,j,l,k,n
c
      double precision zero
      parameter (zero=0.0D0) 
c
c######################################################################
c
      write (lu,3000) prname(:lth)
c
      write (lu,2000) gxx,gyy,gzz
      write (lu,2010) in2
      if (in2.ne.0) write (lu,2020) axx,ayy,azz
      write (lu,2030) b0
      write (lu,2050) dr,dp
      write (lu,2051) dm
      write (lu,2055) d0r,d0p
c
c      write (lu,2100) oss
c
c     write par potential
c
      write (lu,2116) a20,a22
      write (lu,2121) a40,a42
      write (lu,2130) b10,b20
      write (lu,2115) c20,c22
      write (lu,2120) c40,c42
c
      write (lu,2140) psi
      write (lu,2150) bag
      write (lu,2160) bed
      write (lu,2170) lemx,lomx,mmx,kmx,jmx,nmx,imx,ipnmx
      write (lu,2172) lkmtrc
      if (lkmtrc.eq.1) write (lu,2173) lkmdff
      write (lu,2180) nstep
      write (lu,2190) itype
      if (itype.ge.1) then
        write (lu,2200) cgtol
        write (lu,2210) shiftr,shifti
      end if
      if (itype.ge.2) then
        write (lu,3050) fieldi,fieldf
        write (lu,3060) nfield
        write (lu,3070) btol
      end if
c
      write (lu,1000) 
c
      return 
c
c======================================================================
c               format statements
c======================================================================
c
 1000 format(//,2x,70('#'),//)
c
 2000 format(2x,'g-tensor [gxx,gyy,gzz] : ',3(f10.7,2x))
 2010 format(2x,'twice the nuclear spin [in2] : ',i2)
 2020 format(2x,'A-tensor [axx,ayy,azz] (gauss) : ',3(f9.3,2x))
 2030 format(2x,'static field [B0] (gauss) : ',f11.3)
c
 2050 format(2x,'diffusion tensor    [dr,dp,dm] (1/sec) =',2(g11.4,2x))
 2051 format(2x,'diffusion tensor    [dm] (1/sec) =',1(g11.4,2x))
 2055 format(2x,'SRLS diffusion    [d0r,d0p] (1/sec) =',2(g11.4,2x))
c
 2100 format(2x,'Heisenberg spin exchange frequency [oss] = ',g11.4)
c
 2116 format(2x,'a20, a22      = ',2(g11.4,2x))
 2121 format(2x,'a40, a42      = ',2(g11.4,2x))
 2130 format(2x,'b10, b20      = ',2(g11.4,2x))
 2115 format(2x,'c20, c22      = ',2(g11.4,2x))
 2120 format(2x,'c40, c42      = ',2(g11.4,2x))
c
 2140 format(2x,'angle between B0 and local director [psi] ',
     #     '(degrees) : ',f7.2)
 2150 format(2x,'cage tilt [bag] (degrees) = ',f7.2)
c
 2160 format(2x,'diffusion tilt [bed] (degrees) = ',f7.2)
c
 2170 format(2x,'truncation values  [lemx,lomx,mmx,kmx,jmx,nmx,'
     #     ,'imx,ipnmx] : ',8(I2,2x))
 2172 format(2x,'L+K+M truncation rule flag [lkmtrc] : ',i2)
 2173 format(2x,'L+K+M truncation bandwidth [lkmdff] : ',i3)
c
 2180 format(2x,'number of Lanczos/CG steps [nstep] : ',i5)
 2190 format(2x,'calculation type (0=L,1=CG,2=FS) [itype] : ',i1)
 2200 format(2x,'error tolerance for residual [cgtol] : ',g11.4)
 2210 format(2x,'origin shift [shiftr,shifti] :',2(2x,g11.4))
 3000 format(//,2x,25('#'),3x,'file : ',a,3x,25('#'),//)
 3050 format(2x,'field sweep [fieldi,fieldf] ',
     #     '(gauss) : ',f10.3,2x,f10.3)
 3060 format(2x,'number of field positions  : ',i3)
 3070 format(2x,'pruning tolerance : ',g9.3)
c
c======================================================================
c
      end












